Package org.zkoss.stateless.sul

## Interface IListhead

- All Superinterfaces:
    `IChildable<IListhead,​IListheader>`, `IComponent<IListhead>`, `IHeadersElement<IListhead>`, `IHtmlBasedComponent<IListhead>`, `IListboxComposite<IListhead>`, `IMeshComposite<IListhead>`, `IXulElement<IListhead>`

      public interface IListhead
      extends IHeadersElement<IListhead>, IChildable<IListhead,​IListheader>, IListboxComposite<IListhead>

  Immutable `Listhead` component

  A list headers used to define multi-columns and/or headers.

  Author:
    katherine
  See Also:
    `Listhead`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IListhead.Builder` | Builds instances of type `IListhead`.
    `static class` | `IListhead.Updater` | Builds an updater of type `IListhead` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IListhead` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getHeight()` | Returns the height of the component.
    `default java.lang.String` | `getHflex()` | Return horizontal flex hint of this component.
    `default java.lang.String` | `getMenupopup()` | Returns the ID of the Menupopup (`IMenupopup`) that should appear when the user clicks on the element.
    `default java.lang.String` | `getVflex()` | Return vertical flex hint of this component.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default java.lang.String` | `getWidth()` | Returns the width of the component.
    `default boolean` | `isColumnsgroup()` | Returns whether to enable grouping of columns with the header context menu.
    `default boolean` | `isColumnshide()` | Returns whether to enable hiding of columns with the header context menu.
    `static IListhead` | `of​(java.lang.Iterable<? extends IListheader<IAnyGroup>> children)` | Returns the instance with the given `IColumn` children.
    `static IListhead` | `of​(IListheader<IAnyGroup>... children)` | Returns the instance with the given `IColumn` children.
    `static IListhead` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `default void` | `renderProperties​(ContentRenderer renderer)` | Internal use
    `IListhead` | `withColumnsgroup​(boolean columnsgroup)` | Returns a copy of `this` immutable component with the specified `columnsgroup`.
    `IListhead` | `withColumnshide​(boolean columnshide)` | Returns a copy of `this` immutable component with the specified `columnshide`.
    `default IListhead` | `withHeight​(java.lang.String height)` | To control the size of Foot related components, please refer to `IListbox` and `IListhead` instead.
    `default IListhead` | `withHflex​(java.lang.String hflex)` | To control the size of Foot related components, please refer to `IListbox` and `IListhead` instead.
    `IListhead` | `withMenupopup​(java.lang.String menupopup)` | Returns a copy of `this` immutable component with the specified `menupopup`.
    `default IListhead` | `withVflex​(java.lang.String vflex)` | To control the size of Foot related components, please refer to `IListbox` and `IListhead` instead.
    `default IListhead` | `withWidth​(java.lang.String width)` | To control the size of Foot related components, please refer to `IListbox` and `IListhead` instead.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHeadersElement

      `isSizable, withSizable`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IListhead DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.sel.Listhead"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IListhead>`
      Returns:

    - #### getWidth

          @Derived
          @Nullable
          default java.lang.String getWidth()

      Description copied from interface: `IHtmlBasedComponent`
      Returns the width of the component. If not specified, `null` is assumed.

      Default: `null`

      Specified by:
        `getWidth` in interface `IHtmlBasedComponent<IListhead>`

    - #### withWidth

          default IListhead withWidth​(@Nullable
                                      java.lang.String width)

      To control the size of Foot related components, please refer to `IListbox` and `IListhead` instead.
      Specified by:
        `withWidth` in interface `IHtmlBasedComponent<IListhead>`
      Parameters:
        `width` - The width of the component.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getHflex

          @Derived
          @Nullable
          default java.lang.String getHflex()

      Description copied from interface: `IHtmlBasedComponent`
      Return horizontal flex hint of this component.

      Default: `null`

      Specified by:
        `getHflex` in interface `IHtmlBasedComponent<IListhead>`

    - #### withHflex

          default IListhead withHflex​(@Nullable
                                      java.lang.String hflex)

      To control the size of Foot related components, please refer to `IListbox` and `IListhead` instead.
      Specified by:
        `withHflex` in interface `IHtmlBasedComponent<IListhead>`
      Parameters:
        `hflex` - The horizontal flex hint.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getHeight

          @Derived
          @Nullable
          default java.lang.String getHeight()

      Description copied from interface: `IHtmlBasedComponent`
      Returns the height of the component. If not specified, `null` is assumed.

      Default: `null`

      Specified by:
        `getHeight` in interface `IHtmlBasedComponent<IListhead>`

    - #### withHeight

          default IListhead withHeight​(@Nullable
                                       java.lang.String height)

      To control the size of Foot related components, please refer to `IListbox` and `IListhead` instead.
      Specified by:
        `withHeight` in interface `IHtmlBasedComponent<IListhead>`
      Parameters:
        `height` - The height of the component.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getVflex

          @Derived
          @Nullable
          default java.lang.String getVflex()

      Description copied from interface: `IHtmlBasedComponent`
      Return vertical flex hint of this component.

      Default: `null`

      Specified by:
        `getVflex` in interface `IHtmlBasedComponent<IListhead>`

    - #### withVflex

          default IListhead withVflex​(@Nullable
                                      java.lang.String vflex)

      To control the size of Foot related components, please refer to `IListbox` and `IListhead` instead.
      Specified by:
        `withVflex` in interface `IHtmlBasedComponent<IListhead>`
      Parameters:
        `vflex` - The vertical flex hint.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### isColumnshide

          default boolean isColumnshide()

      Returns whether to enable hiding of columns with the header context menu.

      Default: `true`.

    - #### withColumnshide

          IListhead withColumnshide​(boolean columnshide)

      Returns a copy of `this` immutable component with the specified `columnshide`.

      Sets whether to enable hiding of columns with the header context menu.

      Parameters:
        `columnshide` - Whether to enable hiding of columns with the header context menu.

        Default: `true`.

      Returns:
        A modified copy of the `this` object

    - #### isColumnsgroup

          default boolean isColumnsgroup()

      Returns whether to enable grouping of columns with the header context menu.

      Default: `true`.

    - #### withColumnsgroup

          IListhead withColumnsgroup​(boolean columnsgroup)

      Returns a copy of `this` immutable component with the specified `columnsgroup`.

      Sets whether to enable grouping of columns with the header context menu.

      Parameters:
        `columnsgroup` - Whether to enable grouping of columns with the header context menu.

        Default: `true`.

      Returns:
        A modified copy of the `this` object

    - #### getMenupopup

          default java.lang.String getMenupopup()

      Returns the ID of the Menupopup (`IMenupopup`) that should appear when the user clicks on the element.

      Default: `"none"` (a default menupopup).

    - #### withMenupopup

          IListhead withMenupopup​(java.lang.String menupopup)

      Returns a copy of `this` immutable component with the specified `menupopup`.

      Sets the ID of the menupopup (`IMenupopup`) that should appear when the user clicks on the element of each column.

      Parameters:
        `menupopup` - The ID of the menupopup (`IMenupopup`) that should appear when the user clicks on the element of each column.

        Default: `"none"`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static IListhead of​(java.lang.Iterable<? extends IListheader<IAnyGroup>> children)

      Returns the instance with the given `IColumn` children.
      Parameters:
        `children` - The children of `IColumn`

    - #### of

          static IListhead of​(IListheader<IAnyGroup>... children)

      Returns the instance with the given `IColumn` children.
      Parameters:
        `children` - The children of `IColumn`

    - #### ofId

          static IListhead ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component

    - #### renderProperties

          default void renderProperties​(ContentRenderer renderer)
                                 throws java.io.IOException

      Internal use
      Specified by:
        `renderProperties` in interface `IComponent<IListhead>`
      Specified by:
        `renderProperties` in interface `IHeadersElement<IListhead>`
      Specified by:
        `renderProperties` in interface `IHtmlBasedComponent<IListhead>`
      Specified by:
        `renderProperties` in interface `IXulElement<IListhead>`
      Parameters:
        `renderer` -
      Throws:
        `java.io.IOException`